import type { RouteRecordRaw } from "vue-router";
import Middleware from "@/js/contexts/shared/models/Middleware";
import { Permission } from "@/js/contexts/shared/models/Permission";

const routes: RouteRecordRaw[] = [
  {
    name: "admin.users",
    path: "/admin/users",
    component: () => import("@/js/contexts/admin/users/ui/pages/UsersListPage.vue"),
    meta: {
      middleware: [Middleware.auth],
      permissions: [Permission.ADMIN_USERS_VIEW],
    },
    children: [
      {
        name: "admin.users.create",
        path: "/admin/users/create",
        component: () => import("@/js/contexts/admin/users/ui/pages/UsersCreatePage.vue"),
        meta: {
          middleware: [Middleware.auth],
          permissions: [Permission.ADMIN_USERS_CREATE],
        },
      },
      {
        name: "admin.users.update",
        path: "/admin/users/:id",
        component: () => import("@/js/contexts/admin/users/ui/pages/UsersUpdatePage.vue"),
        meta: {
          middleware: [Middleware.auth],
          permissions: [Permission.ADMIN_USERS_UPDATE],
        },
      },
    ],
  },
];

export default routes;
